// Copyright (C) 2001-2005 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
//

package de.uka.ilkd.key.logic;

import de.uka.ilkd.key.java.Services;
import de.uka.ilkd.key.logic.op.SVSubstitute;
import de.uka.ilkd.key.rule.MatchConditions;
import de.uka.ilkd.key.util.Debug;

public class EverythingLocationDescriptor implements LocationDescriptor {
    public static final EverythingLocationDescriptor INSTANCE = new EverythingLocationDescriptor();

    private EverythingLocationDescriptor() {
    }

    public MatchConditions match(SVSubstitute descriptor, MatchConditions mc,
            Services services) {
        if (descriptor == this) return mc;
        Debug.out("Match FAILED. The everything location descriptor cannot match", 
                descriptor);
        return null;
    }

    public String toString() {
        return "*";
    }
}
