// Copyright (C) 2001-2005 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
//

package de.uka.ilkd.key.logic;

import de.uka.ilkd.key.java.Services;
import de.uka.ilkd.key.logic.op.SVSubstitute;
import de.uka.ilkd.key.rule.MatchConditions;

public interface LocationDescriptor extends SVSubstitute{
 
    /** tries to match this location descriptor(the template) against the given 
     * <code>descriptor</code> respecting already found instantiations of schemavariables
     * or of other constraints contained in the MatchConditons <code>mc</code>
     * @param descriptor the SVSubstitute to be matched against
     * @param mc the MatchConditons which have been already found
     * @param services the {@link Services} 
     * @return the resulting matchconditions or <code>null</code> if the given
     * <code>descriptor</code> does not be matched against this location descriptor
     */
    MatchConditions match(SVSubstitute descriptor, 
            MatchConditions mc, Services services);
    
    
}
